Attribute VB_Name = "modCustomWinsock"
Option Explicit

Public Declare Function bind Lib "wsock32.dll" (ByVal S As Long, addr As sockaddrTYPES, ByVal namelen As Long) As Long
Public Declare Function closesocket Lib "wsock32.dll" (ByVal S As Long) As Long
Public Declare Function htons Lib "wsock32.dll" (ByVal hostshort As Long) As Integer
Public Declare Function inet_addr Lib "wsock32.dll" (ByVal CP As String) As Long
Public Declare Function recvfrom Lib "wsock32.dll" (ByVal S As Long, buf As Any, ByVal buflen As Long, ByVal flags As Long, from As sockaddrTYPES, fromlen As Long) As Long
Public Declare Function sendto Lib "wsock32.dll" (ByVal S As Long, buf As Any, ByVal buflen As Long, ByVal flags As Long, to_addr As sockaddrTYPES, ByVal tolen As Long) As Long
Public Declare Function socket Lib "wsock32.dll" (ByVal af As Long, ByVal s_type As Long, ByVal protocol As Long) As Long
Public Declare Function gethostbyname Lib "wsock32.dll" (ByVal host_name As String) As Long
Public Declare Function WSAStartup Lib "wsock32.dll" (ByVal wVR As Long, lpWSAD As WSAdataTYPES) As Long
Public Declare Function WSACleanup Lib "wsock32.dll" () As Long
Public Declare Function WSAAsyncSelect Lib "wsock32.dll" (ByVal S As Long, ByVal hwnd As Long, ByVal wMsg As Long, ByVal lEvent As Long) As Long

'SocketType property values
Public Const SOCK_TCP = 1 'PF_INET, SOCK_TCP, IPPROTO_TCP)
Public Const SOCK_UDP = 2 'PF_INET, SOCK_UDP, IPPROTO_UDP)
Public Const SOCK_IP = 3  'PF_INET, SOCK_UDP, IPPROTO_IP)

Public Enum FD
 FD_READ = 1
 FD_WRITE = 2
 FD_OOB = 4
 FD_ACCEPT = 8
 FD_CONNECT = 16
 FD_CLOSE = 32
 FD_SETSIZE = 64
End Enum
Global Const FD_ALL = 1 Or 2 Or 4 Or 8 Or 16 Or 32 Or 64

Public Type hostentTYPES
 h_name As Long
 h_aliases As Long
 h_addrtype As Integer
 h_length As Integer
 h_addr_list As Long
End Type
Public hostent As hostentTYPES

Public Type WSAdataTYPES
 wVersion As Integer
 wHighVersion As Integer
 szDescription As String * 257
 szSystemStatus As String * 129
 iMaxSockets As Integer
 iMaxUdpDg As Integer
 lpVendorInfo As Long
End Type
Public WSAdata As WSAdataTYPES

Public Type sockaddrTYPES
 sin_family As Integer
 sin_port As Integer
 sin_addr As Long
 sin_zero As String * 8
End Type

'SSL structures
'Public Type SecureMessage
' Message As String
' ResendCount As Integer
'End Type
'Public Secures(1 To 20) As SecureMessage

'API calls
Public Declare Function SetWindowLongA Lib "user32" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function CallWindowProcA Lib "user32" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

'Constants
Private Const GWL_WNDPROC = -4

'Winsock window handle
Private WinsockWindow As Long
Private OldWinsockWindow As Long

'Init/Destroy
Public Sub StartWinsock()
WSAStartup 257, WSAdata
WinsockWindow = frmServerList.hwnd
OldWinsockWindow = SetWindowLongA(WinsockWindow, GWL_WNDPROC, AddressOf WindowProc)
End Sub

Public Sub EndWinsock()
SetWindowLongA WinsockWindow, GWL_WNDPROC, OldWinsockWindow
WSACleanup
End Sub

'CONNECT/DISCONNECT/CLEANUP
Public Sub Connect(IP As String, Port As Integer)
'ResetSession

'frmServerList.SSL.Enabled = True

StartWinsock
Dim L As Long
L = socket(2, 2, 17)
bind L, CurrentSock, 16
SockID = L
WSAAsyncSelect L, WinsockWindow, 5150, FD_ALL
CurrentSock.sin_addr = Host2Long(IP)
CurrentSock.sin_port = htons(Port)
CurrentSock.sin_family = SOCK_UDP

UDPSendNE Packet01
End Sub

Public Sub LeaveServer()
UDPSendNE Packet07

WSAAsyncSelect SockID, WinsockWindow, 0, 0
closesocket SockID
EndWinsock

'frmserverlist.SSL.Enabled = False
End Sub

'Secure socket language
'Public Sub AddSecure(Message As String)
'Dim i As Integer
'For i = 1 To 20
' If Secures(i).ResendCount = 0 Then
'  Secures(i).Message = Message
'  Secures(i).ResendCount = 1
'  Exit Sub
' End If
'Next
'End Sub

'Public Sub ReceivedACK(ACKMessage As String)
'Dim i As Integer
'For i = 1 To 20
' If Mid(Secures(i).Message, 3, 2) = Mid(ACKMessage, 3, 2) Then
'  Secures(i).ResendCount = 0
'  Exit Sub
' End If
'Next
'End Sub

'Public Sub ResendMessages()
'Dim i As Integer
'For i = 1 To 20
' If Secures(i).ResendCount <> 0 Then
'  UDPSendNE Secures(i).Message
'  Secures(i).ResendCount = Secures(i).ResendCount + 1
'  If Secures(i).ResendCount > 5 Then Secures(i).ResendCount = 0
' End If
'Next
'End Sub

'Public Sub ClearSecures()
'Dim i As Integer
'For i = 1 To 20
' Secures(i).ResendCount = 0
'Next
'End Sub

Public Sub UDPSend(Message As String)
sendto SockID, ByVal Message, Len(Message), 0, CurrentSock, 16
'If Asc(Mid(Message, 2, 1)) = 3 Then AddSecure Message
End Sub

Public Sub UDPSendNE(Message As String)
sendto SockID, ByVal Message, Len(Message), 0, CurrentSock, 16
End Sub

'Winsock window callback
Private Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Dim mStr As String * 520, mLen As Integer

If uMsg = 5150 Then
 Select Case Int(lParam Mod 65536)
 Case FD.FD_READ
  mLen = recvfrom(wParam, ByVal mStr, 520, 0, CurrentSock, 16)
  If mLen > 0 Then
   Select Case SERVER_TYPE
   Case GameServer
   Case DirectoryServer: HandleDirectoryServer Left(mStr, mLen)
   Case BillingServer
   End Select
  End If
 Case FD.FD_CONNECT
 Case FD.FD_CLOSE
 Case FD.FD_ACCEPT
 End Select
Else
 WindowProc = CallWindowProcA(OldWinsockWindow, hwnd, uMsg, wParam, ByVal lParam)
End If
End Function

'Winsock utilities
Function Long2IP(Address As Long) As String
Dim S As String * 4
S = GetString(Address)
Long2IP = CStr(Asc(Mid(S, 1, 1))) + "." + CStr(Asc(Mid(S, 2, 1))) + "." + CStr(Asc(Mid(S, 3, 1))) + "." + CStr(Asc(Mid(S, 4, 1)))
End Function

'Public Function IP2Long(ByVal HostName As String) As Long
'Dim phe As Long, addrList As Long, retIP As Long

'retIP = inet_addr(HostName)
'If retIP = &HFFFF Then
' phe = gethostbyname(HostName)
' If phe <> 0 Then
'  CopyMemory hostent, phe, 16
'  CopyMemory addrList, hostent.h_addr_list, 4
'  CopyMemory retIP, addrList, hostent.h_length
' Else
'  retIP = &HFFFF
' End If
'End If

'IP2Long = retIP
'End Function

Function Host2Long(szHost As String) As Long
Dim pPointer As Long
Dim lAddr As Long
Dim lAddr2 As Long

pPointer = gethostbyname(szHost)
CopyMemory hostent.h_name, ByVal pPointer, Len(hostent)
CopyMemory lAddr, ByVal hostent.h_addr_list, 4
CopyMemory lAddr2, ByVal lAddr, 4
Host2Long = lAddr2
End Function
